clang 8.0.0

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::CFGCXXRecordTypedCall Class Reference

Represents a function call that returns a C++ object by value. More...

`#include "clang/Analysis/CFG.h"`

Inheritance diagram for clang::CFGCXXRecordTypedCall:
[legend]
Collaboration diagram for clang::CFGCXXRecordTypedCall:
[legend]

## Public Member Functions
| CFGCXXRecordTypedCall (Expr *E, const ConstructionContext *C)
const ConstructionContext * | getConstructionContext () const
Public Member Functions inherited from clang::CFGStmt
| CFGStmt (Stmt *S, Kind K=Statement)
const Stmt * | getStmt () const
Public Member Functions inherited from clang::CFGElement
template<typename T >
T | castAs () const
| Convert to the specified CFGElement type, asserting that this CFGElement is of the desired type. More...
template<typename T >
Optional< T > | getAs () const
| Convert to the specified CFGElement type, returning None if this CFGElement is not of the desired type. More...
Kind | getKind () const

## Static Public Member Functions
static bool | isCXXRecordTypedCall (Expr *E)
| Returns true when call expression `CE` needs to be represented by CFGCXXRecordTypedCall, as opposed to a regular CFGStmt. More...

## Friends
class | CFGElement

## Additional Inherited Members
Public Types inherited from clang::CFGElement
enum | Kind { Initializer, ScopeBegin, ScopeEnd, NewAllocator, LifetimeEnds, LoopExit, Statement, Constructor, CXXRecordTypedCall, STMT_BEGIN = Statement, STMT_END = CXXRecordTypedCall, AutomaticObjectDtor, DeleteDtor, BaseDtor, MemberDtor, TemporaryDtor, DTOR_BEGIN = AutomaticObjectDtor, DTOR_END = TemporaryDtor }
Protected Member Functions inherited from clang::CFGStmt
| CFGStmt ()=default
Protected Member Functions inherited from clang::CFGElement
| CFGElement (Kind kind, const void *Ptr1, const void *Ptr2=nullptr)
| CFGElement ()=default
Protected Attributes inherited from clang::CFGElement
llvm::PointerIntPair< void *, 2 > | Data1
llvm::PointerIntPair< void *, 2 > | Data2

## Detailed Description

Represents a function call that returns a C++ object by value.

This, like constructor, requires a construction context in order to understand the storage of the returned object . In C such tracking is not necessary because no additional effort is required for destroying the object or modeling copy elision. Like CFGConstructor, this element is for now only used by the analyzer's CFG.

Definition at line 179 of file CFG.h.

## Constructor & Destructor Documentation

## ◆ CFGCXXRecordTypedCall()

clang::CFGCXXRecordTypedCall::CFGCXXRecordTypedCall | ( | Expr * | E,
|  | const ConstructionContext * | C
| ) |  |
| inline explicit

Definition at line 192 of file CFG.h.

References clang::CFGElement::Data2.

## Member Function Documentation

## ◆ getConstructionContext()

const ConstructionContext* clang::CFGCXXRecordTypedCall::getConstructionContext | ( |  | ) | const
| inline

Definition at line 204 of file CFG.h.

References clang::CFGElement::Data2.

## ◆ isCXXRecordTypedCall()

static bool clang::CFGCXXRecordTypedCall::isCXXRecordTypedCall | ( | Expr * | E | ) |
| inline static

Returns true when call expression `CE` needs to be represented by CFGCXXRecordTypedCall, as opposed to a regular CFGStmt.

Definition at line 183 of file CFG.h.

References clang::Type::getAsCXXRecordDecl(), clang::QualType::getCanonicalType(), clang::Expr::getType(), and clang::Expr::isGLValue().

Referenced by FindVA().

## Friends And Related Function Documentation

## ◆ CFGElement

friend class CFGElement
| friend

Definition at line 209 of file CFG.h.

The documentation for this class was generated from the following file:

- include/clang/Analysis/CFG.h